defmodule SumProcess do
  use GenServer

  def sum(pid, list) do
    GenServer.call(pid, {:sum, list})
  end

  def start_link do
    GenServer.start_link(__MODULE__, nil)
  end

  def handle_call({:sum, list}, _from, _state) do
    {:reply, Enum.sum(list), _state}
  end
end

{:ok, pid} = SumProcess.start_link
IO.puts SumProcess.sum(pid, 1..10)
