defmodule StackServer do
  use GenServer

  def push(item) do
    GenServer.cast(:stack, {:push, item})
  end

  def pop do
    GenServer.call(:stack, :pop)
  end

  def start_link do
    GenServer.start_link(__MODULE__, [], name: :stack)
  end

  def handle_cast({:push, item}, state) do
    {:noreply, [item|state]}
  end  

  def handle_call(:pop, _from, []) do
    {:reply, nil, []}
  end
  
  def handle_call(:pop, _from, [h|t]) do
    {:reply, h, t}
  end
end
